<template>
  <div class="data-loader-container container d-flex flex-grow-1 flex-column">
    <div class="my-auto">
      <template v-if="error">
        <div class="text-center">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error.msg }}</div>
        </div>
      </template>
      <template v-else>
        <span class="align-middle">
          <clip-loader :loading="loading" color="#5656f9" size="50px" radius="100%"></clip-loader>
        </span>
        <span class="align-middle">
          <img src="@/assets/images/logo-ipma.png" class="mx-auto d-block">
        </span>
        <h2 class="text-center">Innometeo</h2>
      </template>
    </div>
  </div>
</template>

<script>
import { SET_LOADING_STATUS } from '@/store'
import { createStationsService, createStationsLayerGroup, createStationsLayers } from '@/core/stations'
import ClipLoader from 'vue-spinner/src/ClipLoader'

export default {
  name: 'dataloader',

  computed: {
    loading: {
      get() {
        return this.$store.state.loading
      }
    },
  },

  data() {
    return {
      color: '#ff0000',
      size: '20',
      error: null,
    }
  },

  created() {
    Promise.all([
      this.$store.dispatch('fetchServices'),
      this.$store.dispatch('fetchLayerGroups'),
      this.$store.dispatch('fetchLayers'),
      this.$store.dispatch('fetchLocationGroups'),
      this.$store.dispatch('fetchLocations'),
      this.$store.dispatch('fetchPanes')
    ]).then(() => {
      this.$store.commit(SET_LOADING_STATUS, { value: false })
    }).catch(() => {
      this.error = {
        msg: 'Ocorreu um erro ao iniciar a aplicação. Por favor tente mais tarde.',
      }
    })

    createStationsService(this.$store)
    createStationsLayerGroup(this.$store)
    createStationsLayers(this.$store)

    window.console.log(this.$store)
  },

  components: {
    ClipLoader,
  },
}
</script>

<style scoped>
.error-message {
  margin-top: 1rem;
  padding-top: 1rem;
  border-top: darkgrey solid 1px;
}
</style>
